/*
   simpleviewer and streamviewer
*/

extern int servo1Pos, servo2Pos;  //%%%ver-servo%%%

const uint8_t index_simple_html[] = R"=====(<!doctype html>
<html>
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <title id="title">ESP32-CAM Simplified View</title>
    <link rel="icon" type="image/png" sizes="32x32" href="/favicon-32x32.png">
    <link rel="icon" type="image/png" sizes="16x16" href="/favicon-16x16.png">
    <link rel="stylesheet" type="text/css" href="/style.css">
    <style>
      @media (min-width: 800px) and (orientation:landscape) {
        #content {
          display:flex;
          flex-wrap: nowrap;
          flex-direction: column;
          align-items: flex-start;
        }
      }
    </style>
    <script type="text/javascript" src="/plik.js"></script>
  </head>

  <body onload="aktualizacja_odczytow()"> <!-- %%%ver-servo%%% -->
    <section class="main">
      <div id="logo">
        <label for="nav-toggle-cb" id="nav-toggle" style="float:left;" title="Settings">&#9776;&nbsp;</label>
        <button id="swap-viewer" style="float:left;" title="Swap to full feature viewer">Full</button>
        <button id="get-still" style="float:left;">Get Still</button>
        <button id="toggle-stream" style="float:left;" class="hidden">Start Stream</button>
        <div id="wait-settings" style="float:left;" class="loader" title="Waiting for camera settings to load"></div>
      </div>
      <div id="content">
        <div class="hidden" id="sidebar">
          <input type="checkbox" id="nav-toggle-cb">
            <nav id="menu" style="width:24em;">
              <div class="input-group hidden" id="lamp-group">
                <label for="lamp">Light</label>
                <div class="range-min">Off</div>
                <input type="range" id="lamp" min="0" max="100" value="0" class="action-setting">
                <div class="range-max">Full</div>
              </div>
              <div class="input-group" id="framesize-group">
                <label for="framesize">Resolution</label>
                <select id="framesize" class="action-setting">
                  <option value="13">UXGA (1600x1200)</option>
                  <option value="12">SXGA (1280x1024)</option>
                  <option value="11">HD (1280x720)</option>
                  <option value="10">XGA (1024x768)</option>
                  <option value="9">SVGA (800x600)</option>
                  <option value="8">VGA (640x480)</option>
                  <option value="7">HVGA (480x320)</option>
                  <option value="6">CIF (400x296)</option>
                  <option value="5">QVGA (320x240)</option>
                  <option value="3">HQVGA (240x176)</option>
                  <option value="1">QQVGA (160x120)</option>
                  <option value="0">THUMB (96x96)</option>
                </select>
              </div>
              <!-- Hide the next entries, they are present in the body so that we
                  can pass settings to/from them for use in the scripting, not for user setting -->
              <div id="rotate" class="action-setting hidden"></div>
              <div id="cam_name" class="action-setting hidden"></div>
              <div id="stream_url" class="action-setting hidden"></div>
              
<!-- %%%ver-servo%%%###przyciski sterujące serwami### -->
                <table>
                  <tr>
                    <td align="center"><button class="button" onmousedown="buttonOn('s_up');" ontouchstart="buttonOn('s_up');"
                      onmouseup="buttonOff();" ontouchend="buttonOff();" ><b><big>&#8593</big></b></button></td>
                    <td align="center"><button class="button" onmousedown="buttonOn('s_down');" ontouchstart="buttonOn('s_down');"
                      onmouseup="buttonOff();" ontouchend="buttonOff();" ><b><big>&#8595</big></b></button></td>
                    <td align="left"><p>: <span id="var_servo1Pos"></span></p></td>

                    <td align="center"><button class="button" onmousedown="buttonOff();" ontouchstart="buttonOff();" >STOP</button></td>

                    <td align="left"><p>: <span id="var_servo2Pos"></span></p></td>
                    <td align="center"><button class="button" onmousedown="buttonOn('s_left');" ontouchstart="buttonOn('s_left');"
                      onmouseup="buttonOff();" ontouchend="buttonOff();" ><b><big>&#8592</big></b></button></td>
                    <td align="center"><button class="button" onmousedown="buttonOn('s_right');" ontouchstart="buttonOn('s_right');"
                      onmouseup="buttonOff();" ontouchend="buttonOff();" ><b><big>&#8594</big></b></button></td>
                  </tr>
                </table>
              <!-- ### -->
            </nav>
        </div>
         <figure> 
<!-- %%%ver-servo%%%###suwak poziomy### --> 
        <div class="hidden" id="suwak_poziom">       
                  <nav> 
            <label for="range_h" style="padding: 0 20px;">&#8592;&#8594; </label>
            <!--<input type="range" id="range_h"  onmousemove="rangeSliderH(this.value)" onchange="rangeSliderH(this.value)"
                   min="0" max="180" step = "1" style="width: 250px;height: 8px; padding: 3px 0 3px 0;">-->
            <input type="range" id="range_h"  onchange="myFunction('poz-h');"
                   min="0" max="180" step = "1" style="width: 250px;height: 8px; padding: 3px 0 3px 0;">
                   
                 </nav> 
       </div>
<!-- ### -->         

          <div id="stream-container" class="image-container hidden">   
              <div class="close close-rot-none" id="close-stream">×</div>
<!-- %%%ver-servo%%%###suwak pionowy### -->              
                <div align="center" class="hidden" id="suwak_pion">
                  <input type = "range" id="range_v" onchange="myFunction('poz-v');"
                     min = "0" max = "180" step = "1"  style=" width: 250px; height: 8px; padding:  3px 0 3px 0;" > 
                    <label for="range_v" style="padding: 0 20px;"><span style="writing-mode: vertical-rl;">&#8593;&#8595; </span></label>
               </div>
<!-- ### --> 
             <img id="stream" src="">  
                        
        </div>
        </figure> 
 </div> 
    </section>
  </body>

    <script>
//%%%ver-servo%%%#######
  var x=0,y=0,s_bak="",s,poz_abs, blokada_powtorzen=0;
  let timeoutID;
  var x_min=0,x_max=0,x_cen=0,y_min=0,y_max=0,y_cen=0;

//###funkcja naciskania klawiszy sterujących serwami###
function rangeSliderH(value){
var test;  
    test=Math.abs(value-x);
    if (test<2) return;
    x = value;
    s="s_horizon";
    poz_abs=x;
    document.getElementById('var_servo2Pos').innerHTML = value;
    var xhr = new XMLHttpRequest();
    xhr.open("GET", "/servo?var=" + s + "&val=" + poz_abs, true);
    xhr.send();
};

  function myFunction(st) {
    if (st=="poz-h")
    {
      var yt = document.getElementById("range_h").value;
      yt=180 -yt;
      if (yt<y_min) yt=y_min;
      if (yt>y_max) yt=y_max;
      document.getElementById("var_servo2Pos").innerHTML = yt;
      var y_tmp =180-yt;
      document.getElementById("range_h").value = y_tmp;
      s="s_horizon";
      poz_abs=yt;
      y=yt;
    }
    if (st=="poz-v")
    {
      var xt = document.getElementById("range_v").value;
      xt =180 -xt;
      if (xt<x_min) xt=x_min;
      if (xt>x_max) xt=x_max;
      document.getElementById("var_servo1Pos").innerHTML = xt;
      var x_tmp =180-xt;
      document.getElementById("range_v").value = x_tmp;
      s="s_vertic";
      poz_abs=xt;
      x=xt;
    }   
     var xhr = new XMLHttpRequest();
     xhr.open("GET", "/servo?var=" + s + "&val=" + poz_abs, true);
     xhr.send();

}

     function buttonOn(st) {
       poz_abs =-1;
  
       if (s=="s_stop") return;
       if(st == null)
       {
          if (blokada_powtorzen==0)
          {
            s=s_bak;
            timeoutID = setTimeout(buttonOn, 300);
          }else s="";
       }
       else 
       {
        s_bak=st;
        s=st;
        timeoutID = setTimeout(buttonOn, 300);
        blokada_powtorzen=0;
     }
    
     if (s=="s_up")
     {
      if (x>0 && x>x_min) x=x-1;
      poz_abs=x;
      s="s_vertic";
     }
     if (s=="s_down")
     {
      if (x<180 && x<x_max) x=x+1;
      poz_abs=x;
      s="s_vertic";
     }
     if (s=="s_right")
     {
      if (y>0 && y>y_min) y=y-1;
      poz_abs=y;
      s="s_horizon";
     }
     if (s=="s_left")
     {
      if (y<180 && y<y_max) y=y+1;
      poz_abs=y;
      s="s_horizon";
     }
     
     document.getElementById("var_servo1Pos").innerHTML = x;
     document.getElementById("var_servo2Pos").innerHTML = y;
     var x_tmp =180-x;
     var y_tmp =180-y;
     document.getElementById("range_v").value = x_tmp;
     document.getElementById("range_h").value = y_tmp;

    var xhr = new XMLHttpRequest();
     xhr.open("GET", "/servo?var=" + s + "&val=" + poz_abs, true);
     xhr.send();
   }

   function buttonOff()
   {
    clearTimeout(timeoutID);
    blokada_powtorzen=1;
//    setTimeout(buttonOn,100);
   }

   function aktualizacja_odczytow(){
var x_tmp, y_tmp;    
    odczyt_zmiennych_zewnetrznych();
    document.getElementById("var_servo1Pos").innerHTML = x;
    document.getElementById("var_servo2Pos").innerHTML = y;
    x_tmp =180-x;
    y_tmp =180-y;
    document.getElementById("range_v").value = x_tmp;
    document.getElementById("range_h").value = y_tmp;
   }
//######
  
  document.addEventListener('DOMContentLoaded', function (event) {
    var baseHost = document.location.origin;
    var streamURL = 'Undefined';

    const settings = document.getElementById('sidebar')
    const waitSettings = document.getElementById('wait-settings')
    const lampGroup = document.getElementById('lamp-group')
    const rotate = document.getElementById('rotate')
    const view = document.getElementById('stream')
    const viewContainer = document.getElementById('stream-container')
    const viewContainer1 = document.getElementById('suwak_poziom')  //%%%ver-servo%%%
    const viewContainer2 = document.getElementById('suwak_pion')    //%%%ver-servo%%%
    
    const stillButton = document.getElementById('get-still')
    const streamButton = document.getElementById('toggle-stream')
    const closeButton = document.getElementById('close-stream')
    const swapButton = document.getElementById('swap-viewer')

    const hide = el => {
      el.classList.add('hidden')
    }
    const show = el => {
      el.classList.remove('hidden')
    }

    const disable = el => {
      el.classList.add('disabled')
      el.disabled = true
    }

    const enable = el => {
      el.classList.remove('disabled')
      el.disabled = false
    }

    const updateValue = (el, value, updateRemote) => {
      updateRemote = updateRemote == null ? true : updateRemote
      let initialValue
      if (el.type === 'checkbox') {
        initialValue = el.checked
        value = !!value
        el.checked = value
      } else {
        initialValue = el.value
        el.value = value
      }

      if (updateRemote && initialValue !== value) {
        updateConfig(el);
      } else if(!updateRemote){
        if(el.id === "lamp"){
          if (value == -1) { 
            hide(lampGroup)
          } else {
            show(lampGroup)
          }
        } else if(el.id === "cam_name"){
          window.document.title = value;
          console.log('Name set to: ' + value);
        } else if(el.id === "code_ver"){
          console.log('Firmware Build: ' + value);
        } else if(el.id === "rotate"){
          rotate.value = value;
          applyRotation();
        } else if(el.id === "stream_url"){
          streamURL = value;
          streamButton.setAttribute("title", `Start the stream :: {streamURL}`);
          console.log('Stream URL set to:' + value);
        } 
      }
    }

    var rangeUpdateScheduled = false
    var latestRangeConfig

    function updateRangeConfig (el) {
      latestRangeConfig = el
      if (!rangeUpdateScheduled) {
        rangeUpdateScheduled = true;
        setTimeout(function(){
          rangeUpdateScheduled = false
          updateConfig(latestRangeConfig)
        }, 150);
      }
    }

    function updateConfig (el) {
      let value
      switch (el.type) {
        case 'checkbox':
          value = el.checked ? 1 : 0
          break
        case 'range':
        case 'select-one':
          value = el.value
          break
        case 'button':
        case 'submit':
          value = '1'
          break
        default:
          return
      }

      const query = `${baseHost}/control?var=${el.id}&val=${value}`

      fetch(query)
        .then(response => {
          console.log(`request to ${query} finished, status: ${response.status}`)
        })
    }

    document
      .querySelectorAll('.close')
      .forEach(el => {
        el.onclick = () => {
          hide(el.parentNode)
        }
      })

    // read initial values
    fetch(`${baseHost}/status`)
      .then(function (response) {
        return response.json()
      })
      .then(function (state) {
        document
          .querySelectorAll('.action-setting')
          .forEach(el => {
            updateValue(el, state[el.id], false)
          })
        hide(waitSettings);
        show(settings);
        show(streamButton);
        startStream();
      })

    // Put some helpful text on the 'Still' button
    stillButton.setAttribute("title", `Capture a still image :: ${baseHost}/capture`);

    const stopStream = () => {
      window.stop();
      streamButton.innerHTML = 'Start Stream';
          streamButton.setAttribute("title", `Start the stream :: ${streamURL}`);
      hide(viewContainer);
      hide(viewContainer1); //%%%ver-servo%%%
      hide(viewContainer2); //%%%ver-servo%%%
    }

    const startStream = () => {
      view.src = streamURL;
      view.scrollIntoView(false);
      streamButton.innerHTML = 'Stop Stream';
      streamButton.setAttribute("title", `Stop the stream`);
      show(viewContainer);
      if (rot == -90) show(viewContainer1); //%%%ver-servo%%%
      if (rot == -90) show(viewContainer2); //%%%ver-servo%%%
    }

    const applyRotation = () => {
      rot = rotate.value;
      if (rot == -90) {
        viewContainer.style.transform = `rotate(-90deg)  translate(-100%)`;
        closeButton.classList.remove('close-rot-none');
        closeButton.classList.remove('close-rot-right');
        closeButton.classList.add('close-rot-left');
      } else if (rot == 90) {
        viewContainer.style.transform = `rotate(90deg) translate(0, -100%)`;
        closeButton.classList.remove('close-rot-left');
        closeButton.classList.remove('close-rot-none');
        closeButton.classList.add('close-rot-right');
      } else {
        viewContainer.style.transform = `rotate(0deg)`;
        closeButton.classList.remove('close-rot-left');
        closeButton.classList.remove('close-rot-right');
        closeButton.classList.add('close-rot-none');
      }
       console.log('Rotation ' + rot + ' applied');
   }

    // Attach actions to controls

    stillButton.onclick = () => {
      stopStream();
      view.src = `${baseHost}/capture?_cb=${Date.now()}`;
      view.scrollIntoView(false);
      show(viewContainer);
      if (rot == -90) show(viewContainer1); //%%%ver-servo%%%
      if (rot == -90) show(viewContainer2); //%%%ver-servo%%%
    }

    closeButton.onclick = () => {
      stopStream();
      hide(viewContainer);
      hide(viewContainer1); //%%%ver-servo%%%
      hide(viewContainer2); //%%%ver-servo%%%
    }

    streamButton.onclick = () => {
      const streamEnabled = streamButton.innerHTML === 'Stop Stream'
      if (streamEnabled) {
        stopStream();
      } else {
        startStream();
      }
    }

    // Attach default on change action
    document
      .querySelectorAll('.action-setting')
      .forEach(el => {
        el.onchange = () => updateConfig(el)
      })

    // Update range sliders as they are being moved
    document
      .querySelectorAll('input[type="range"]')
      .forEach(el => {
        el.oninput = () => updateRangeConfig(el)
      })

    // Custom actions
    // Detection and framesize
    rotate.onchange = () => {
      applyRotation();
      updateConfig(rotate);
    }

    framesize.onchange = () => {
      updateConfig(framesize)
    }

    swapButton.onclick = () => {
      window.open('/?view=full','_self');
    }
  })
  </script>
</html>)=====";

size_t index_simple_html_len = sizeof(index_simple_html) - 1;

/* Stream Viewer */

const uint8_t streamviewer_html[] = R"=====(<!doctype html>
<html>
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <title id="title">ESP32-CAM StreamViewer</title>
    <link rel="icon" type="image/png" sizes="32x32" href="/favicon-32x32.png">
    <link rel="icon" type="image/png" sizes="16x16" href="/favicon-16x16.png">
    <style>
      /* No stylesheet, define all style elements here */
      body {
        font-family: Arial,Helvetica,sans-serif;
        background: #181818;
        color: #EFEFEF;
        font-size: 16px;
        margin: 0px;
        overflow:hidden;
      }

      img {
        object-fit: contain;
        display: block;
        margin: 0px;
        padding: 0px;
        width: 100vw;
        height: 100vh;
      }

      .loader {
        border: 0.5em solid #f3f3f3;
        border-top: 0.5em solid #000000;
        border-radius: 50%;
        width: 1em;
        height: 1em;
        -webkit-animation: spin 2s linear infinite; /* Safari */
        animation: spin 2s linear infinite;
      }

      @-webkit-keyframes spin {   /* Safari */
        0% { -webkit-transform: rotate(0deg); }
        100% { -webkit-transform: rotate(360deg); }
      }

      @keyframes spin {
        0% { transform: rotate(0deg); }
        100% { transform: rotate(360deg); }
      }
    </style>
  </head>

  <body>
    <section class="main">
      <div id="wait-settings" style="float:left;" class="loader" title="Waiting for stream settings to load"></div>
      <div style="display: none;">
        <!-- Hide the next entries, they are present in the body so that we
             can pass settings to/from them for use in the scripting -->
        <div id="rotate" class="action-setting hidden">0</div>
        <div id="cam_name" class="action-setting hidden"></div>
        <div id="stream_url" class="action-setting hidden"></div>
      </div>
      <img id="stream" src="">
    </section>
  </body>

  <script>
  document.addEventListener('DOMContentLoaded', function (event) {
    var baseHost = document.location.origin;
    var streamURL = 'Undefined';

    const rotate = document.getElementById('rotate')
    const stream = document.getElementById('stream')
    const spinner = document.getElementById('wait-settings')

    const updateValue = (el, value, updateRemote) => {
      updateRemote = updateRemote == null ? true : updateRemote
      let initialValue
      if (el.type === 'checkbox') {
        initialValue = el.checked
        value = !!value
        el.checked = value
      } else {
        initialValue = el.value
        el.value = value
      }

      if (updateRemote && initialValue !== value) {
        updateConfig(el);
      } else if(!updateRemote){
        if(el.id === "cam_name"){
          window.document.title = value;
          stream.setAttribute("title", value + "\n(doubleclick for fullscreen)");
          console.log('Name set to: ' + value);
        } else if(el.id === "rotate"){
          rotate.value = value;
          console.log('Rotate recieved: ' + rotate.value);
        } else if(el.id === "stream_url"){
          streamURL = value;
          console.log('Stream URL set to:' + value);
        } 
      }
    }

    // read initial values
    fetch(`${baseHost}/info`)
      .then(function (response) {
        return response.json()
      })
      .then(function (state) {
        document
          .querySelectorAll('.action-setting')
          .forEach(el => {
            updateValue(el, state[el.id], false)
          })
        spinner.style.display = `none`;
        applyRotation();
        startStream();
      })

    const startStream = () => {
      stream.src = streamURL;
      stream.style.display = `block`;
    }

    const applyRotation = () => {
      rot = rotate.value;
      if (rot == -90) {
        stream.style.transform = `rotate(-90deg)`;
      } else if (rot == 90) {
        stream.style.transform = `rotate(90deg)`;
      }
      console.log('Rotation ' + rot + ' applied');
    }

    stream.ondblclick = () => {
      if (stream.requestFullscreen) {
        stream.requestFullscreen();
      } else if (stream.mozRequestFullScreen) { /* Firefox */
        stream.mozRequestFullScreen();
      } else if (stream.webkitRequestFullscreen) { /* Chrome, Safari and Opera */
        stream.webkitRequestFullscreen();
      } else if (stream.msRequestFullscreen) { /* IE/Edge */
        stream.msRequestFullscreen();
      }
    }
  })
  </script>
</html>)=====";

size_t streamviewer_html_len = sizeof(streamviewer_html) - 1;

/* Captive Portal page
   we replace the <> delimited strings with correct values as it is served */

const std::string portal_html = R"=====(<!doctype html>
<html>
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <title id="title"><CAMNAME> - portal</title>
    <link rel="icon" type="image/png" sizes="32x32" href="<APPURL>favicon-32x32.png">
    <link rel="icon" type="image/png" sizes="16x16" href="<APPURL>favicon-16x16.png">
    <link rel="stylesheet" type="text/css" href="<APPURL>style.css">
  </head>
  <body style="text-align: center;">
    <img src="<APPURL>logo.svg" style="position: relative; float: right;">
    <h1><CAMNAME> - access portal</h1>
    <div class="input-group" style="margin: auto; width: max-content;">
      <a href="<APPURL>?view=simple" title="Click here for a simple view with minimum control" style="text-decoration: none;" target="_blank">
      <button>Simple Viewer</button></a>
      <a href="<APPURL>?view=full" title="Click here for the main camera page with full controls" style="text-decoration: none;" target="_blank">
      <button>Full Viewer</button></a>
      <a href="<STREAMURL>view" title="Click here for the dedicated stream viewer" style="text-decoration: none;" target="_blank">
      <button>Stream Viewer</button></a>
    </div>
    <hr>
    <a href="<APPURL>dump" title="Information dump page" target="_blank">Camera Details</a><br>
  </body>
</html>)=====";

/* Error page
   we replace the <> delimited strings with correct values as it is served */

const std::string error_html = R"=====(<!doctype html>
<html>
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <title id="title"><CAMNAME> - Error</title>
    <link rel="icon" type="image/png" sizes="32x32" href="/favicon-32x32.png">
    <link rel="ico\" type="image/png" sizes="16x16" href="/favicon-16x16.png">
    <link rel="stylesheet" type="text/css" href="<APPURL>style.css">
  </head>
  <body style="text-align: center;">
    <img src="<APPURL>logo.svg" style="position: relative; float: right;">
    <h1><CAMNAME></h1>
    <ERRORTEXT>
  </body>
  <script>
    setTimeout(function(){
      location.replace(document.URL);
    }, 60000);
  </script>
</html>)=====";
