/*
 * kod HTML podstrony do ustawiania parametrów:
 * serw
 */

 const uint8_t servo_simple_html[] = R"=====(<!doctype html>
<html>
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <title id="title">ESP32-CAM Servo</title>
    <link rel="icon" type="image/png" sizes="32x32" href="/favicon-32x32.png">
    <link rel="icon" type="image/png" sizes="16x16" href="/favicon-16x16.png">
    <link rel="stylesheet" type="text/css" href="/style.css">
    <style>
      @media (min-width: 800px) and (orientation:landscape) {
        #content {
          display:flex;
          flex-wrap: nowrap;
          flex-direction: column;
          align-items: flex-start;
        }
      }
    </style>    
    <script type="text/javascript" src="/plik.js"></script>
    </head>

  <body onload="wyswietl_zakresy_ograniczen()">
    <!--<section class="main">-->
      <h1>ESP32 Cam Servo</h1>
        <!-- ###tu elementy sterujące serwami głowicy### -->
        <table>
          <tr>
            <td align="center"><button class="button" onmousedown="buttonOn('s_up');" ontouchstart="buttonOn('s_up');"
              onmouseup="buttonOff();" ontouchend="buttonOff();" ><b><big>&#8593</big></b></button></td>
            <td align="center"><button class="button" onmousedown="buttonOn('s_down');" ontouchstart="buttonOn('s_down');"
              onmouseup="buttonOff();" ontouchend="buttonOff();" ><b><big>&#8595</big></b></button></td>
            <td align="left"><p>Vert.pos.: <span id="var_servo1Pos"></span></p></td>

            <td align="center"><button class="button" onmousedown="buttonOff();" ontouchstart="buttonOff();" >STOP</button></td>
            
            <td align="center"><button class="button" onmousedown="buttonOn('s_left');" ontouchstart="buttonOn('s_left');"
              onmouseup="buttonOff();" ontouchend="buttonOff();" ><b><big>&#8592</big></b></button></td>
            <td align="center"><button class="button" onmousedown="buttonOn('s_right');" ontouchstart="buttonOn('s_right');"
              onmouseup="buttonOff();" ontouchend="buttonOff();" ><b><big>&#8594</big></b></button></td>
            <td align="left"><p>Hor.pos.: <span id="var_servo2Pos"></span></p></td>
          </tr>
        </table>
        
        <table>
          <tr>
            <td align="center"><button class="button" onmousedown="testZakresu('s_v_mi');" ontouchstart="testZakresu('s_v_mi');">SET</button></td>
            <td align="left"><p>Vertic.pos.minimum </p></td>
            <td align="left"><p><span id="s_v_mi_val"></span></p></td>
          </tr>
          <tr>
            <td align="center"><button class="button" onmousedown="testZakresu('s_v_ma');" ontouchstart="testZakresu('s_v_ma');">SET</button></td>
            <td align="left"><p>Vertic.pos.maximum </p></td>
            <td align="left"><p><span id="s_v_ma_val"></span></p></td>
          </tr>
          <tr>
            <td align="center"><button class="button" onmousedown="testZakresu('s_v_ce');" ontouchstart="testZakresu('s_v_ce');">SET</button></td>
            <td align="left"><p>Vertic.pos.reset </p></td>
            <td align="left"><p><span id="s_v_ce_val"></span></p></td>
          </tr>
          <tr>
            <td align="center"><button class="button" onmousedown="testZakresu('s_h_mi');" ontouchstart="testZakresu('s_h_mi');">SET</button></td>
            <td align="left"><p>Horizon.pos.minimum </p></td>
            <td align="left"><p><span id="s_h_mi_val"></span></p></td>
          </tr>
          <tr>
            <td align="center"><button class="button" onmousedown="testZakresu('s_h_ma');" ontouchstart="testZakresu('s_h_ma');">SET</button></td>
            <td align="left"><p>Horizon.pos.maximum </p></td>
            <td align="left"><p><span id="s_h_ma_val"></span></p></td>
          </tr>
          <tr>
            <td align="center"><button class="button" onmousedown="testZakresu('s_h_ce');" ontouchstart="testZakresu('s_h_ce');">SET</button></td>
            <td align="left"><p>Horizon.pos.reset </p></td>
            <td align="left"><p><span id="s_h_ce_val"></span></p></td>
          </tr>
        </table>

        <!-- Footer -->
        <br>
        <div class="input-group">
          <table>
            <tr>
              <td align="left">
                <button title="Close this page" onclick="javascript:window.close()">Close</button>
              </td>
              <td width="40%"></td>
              <td>
                <button title="Save servo setup" onmousedown="zapis_ustawien_serw_do_SPIFFS();" ontouchstart="zapis_ustawien_serw_do_SPIFFS();">Save</button>
              </td>
            </tr>
          </table>
        </div>
    <!--</section>-->
  </body>

  <script>
var x=0,y=0,s_bak="",s,poz_abs, blokada_powtorzen=0;
let timeoutID;
var x_min=0,x_max=0,x_cen=0,y_min=0,y_max=0,y_cen=0;

//###funkcja naciskania klawiszy sterujących serwami###
   function buttonOn(st) {
     poz_abs =-1;

     if (s=="s_stop") return;
     if(st == null)
     {
        if (blokada_powtorzen==0)
        {
          s=s_bak;
          timeoutID = setTimeout(buttonOn, 300);
        }else s="";
     }
     else 
     {
      s_bak=st;
      s=st;
      timeoutID = setTimeout(buttonOn, 300);
      blokada_powtorzen=0;
   }
  
   if (s=="s_up")
   {
    if (x>0) x=x-1;
    poz_abs=x;
    s="s_vertic";
   }
   if (s=="s_down")
   {
    if (x<180) x=x+1;
    poz_abs=x;
    s="s_vertic";
   }
   if (s=="s_right")
   {
    if (y>0) y=y-1;
    poz_abs=y;
    s="s_horizon";
   }
   if (s=="s_left")
   {
    if (y<180) y=y+1;
    poz_abs=y;
    s="s_horizon";
   }
   
   document.getElementById("var_servo1Pos").innerHTML = x;
   document.getElementById("var_servo2Pos").innerHTML = y;

   var xhr = new XMLHttpRequest();
   xhr.open("GET", "/servo?var=" + s + "&val=" + poz_abs, true);
   xhr.send();
 }

 function buttonOff()
 {
  clearTimeout(timeoutID);
  blokada_powtorzen=1;
 }

 function testZakresu(st){
 var err=1,val;
  while (1){
    if (st=="s_v_mi"){
       if (x>x_max) break;
       err=0;
       x_min=x; st="s_v_mi_val"; val=x; s="s_vertic_min";
    }
    if (st=="s_v_ma"){
       if (x<x_min) break;
       err=0;
       x_max=x; st="s_v_ma_val"; val=x; s="s_vertic_max";
    }
    if (st=="s_v_ce"){
      if (x<x_min || x>x_max) break;
      err=0;
      x_cen=x; st="s_v_ce_val"; val=x; s="s_vertic_cen";
    }
    if (st=="s_h_mi"){
       if (y>y_max) break;
       err=0;
       y_min=y; st="s_h_mi_val"; val=y; s="s_horizon_min"
    }
    if (st=="s_h_ma"){
       if (y<y_min) break;
       err=0;
       y_max=y; st="s_h_ma_val"; val=y; s="s_horizon_max";  
    }
    if (st=="s_h_ce"){
       if (y<y_min || y>y_max) break;
       err=0;
      y_ce=y; st="s_h_ce_val"; val=y; s="s_horizon_cen";
    }
    break;
  }
  if (err==1) {
    alert("parameter ERROR");
      return;
  }
  document.getElementById(st).innerHTML =val;
   var xhr = new XMLHttpRequest();
   xhr.open("GET", "/servo?var=" + s + "&val=" + val, true);
   xhr.send();  
 }

 function zapis_ustawien_serw_do_SPIFFS(){
   var xhr = new XMLHttpRequest();
   xhr.open("GET", "/servo?var=save_prefs&val=0", true);
   xhr.send();    
 }

 function wyswietl_zakresy_ograniczen(){
  odczyt_zmiennych_zewnetrznych();
  document.getElementById("s_v_mi_val").innerHTML =x_min;
  document.getElementById("s_v_ma_val").innerHTML =x_max;
  document.getElementById("s_v_ce_val").innerHTML =x_cen;
  document.getElementById("s_h_mi_val").innerHTML =y_min;
  document.getElementById("s_h_ma_val").innerHTML =y_max;
  document.getElementById("s_h_ce_val").innerHTML =y_cen;
  document.getElementById("var_servo1Pos").innerHTML = x;
  document.getElementById("var_servo2Pos").innerHTML = y;  
 }
  </script>
</html>)=====";

size_t servo_simple_html_len = sizeof(servo_simple_html) - 1;
